Index: /trunk/Cocoa/Pester/Source/PSAlarm.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlarm.h	(revision 60)
+++ /trunk/Cocoa/Pester/Source/PSAlarm.h	(revision 61)
@@ -23,5 +23,5 @@
 extern NSString * const PSAlarmDiedNotification;
 
-@class PSAlert, PSAlerts;
+@class PSAlert, PSAlerts, PSTimer;
 
 @interface PSAlarm : NSObject <NSCoding, PSPropertyListSerialization> {
@@ -33,5 +33,5 @@
     NSString *alarmMessage;
     NSString *invalidMessage;
-    NSTimer *timer;
+    PSTimer *timer;
     PSAlerts *alerts;
     BOOL repeating;
@@ -45,4 +45,5 @@
 - (void)setRepeating:(BOOL)isRepeating;
 - (void)setSnoozeInterval:(NSTimeInterval)anInterval;
+- (void)setWakeUp:(BOOL)doWake;
 
 - (NSCalendarDate *)date;
Index: /trunk/Cocoa/Pester/Source/PSAlarm.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlarm.m	(revision 60)
+++ /trunk/Cocoa/Pester/Source/PSAlarm.m	(revision 61)
@@ -10,4 +10,5 @@
 #import "PSAlert.h"
 #import "PSAlerts.h"
+#import "PSTimer.h"
 #import "NJRDateFormatter.h"
 #import "NSCalendarDate-NJRExtensions.h"
@@ -143,5 +144,5 @@
 }
 
-- (void)_timerExpired:(NSTimer *)aTimer;
+- (void)_timerExpired:(PSTimer *)aTimer;
 {
     NSLog(@"expired: %@; now %@", [[aTimer fireDate] description], [[NSDate date] description]);
@@ -198,4 +199,9 @@
     NSAssert(alarmType == PSAlarmExpired, @"CanÕt snooze an alarm that hasnÕt expired");
     alarmType = PSAlarmSnooze;
+}
+
+- (void)setWakeUp:(BOOL)doWake;
+{
+    [timer setWakeUp: doWake];
 }
 
@@ -379,8 +385,10 @@
         return NO;
     }
-    timer = [NSTimer scheduledTimerWithTimeInterval: (alarmType == PSAlarmSnooze ? snoozeInterval : alarmInterval) target: self selector: @selector(_timerExpired:) userInfo: nil repeats: NO];
+    timer = [PSTimer scheduledTimerWithTimeInterval: (alarmType == PSAlarmSnooze ? snoozeInterval : alarmInterval) target: self selector: @selector(_timerExpired:) userInfo: nil repeats: NO];
     if (timer == nil) return NO;
     [timer retain];
     alarmType = PSAlarmSet;
+    [alerts prepareForAlarm: self];
+
     [[NSNotificationCenter defaultCenter] postNotificationName: PSAlarmTimerSetNotification object: self];
     // NSLog(@"set: %@; now %@; remaining %@", [[timer fireDate] description], [[NSDate date] description], [self timeRemainingString]);
Index: /trunk/Cocoa/Pester/Source/PSAlarmAlertController.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlarmAlertController.m	(revision 60)
+++ /trunk/Cocoa/Pester/Source/PSAlarmAlertController.m	(revision 61)
@@ -41,6 +41,6 @@
     unsigned count = [pendingAlerts count];
     [pendingAlerts removeObject: alert];
-    NSLog(@"removed: %@; still pending: %@", alert, [pendingAlerts description]);
-    NSLog(@"alarm: %@ retainCount %d", [notification object], [[notification object] retainCount]);
+    // NSLog(@"removed: %@; still pending: %@", alert, [pendingAlerts description]);
+    // NSLog(@"alarm: %@ retainCount %d", [notification object], [[notification object] retainCount]);
     NSAssert2([pendingAlerts count] == count - 1, @"alert not in set: %@\n%@", alert, notification);
     if ([pendingAlerts count] == 0) {
Index: /trunk/Cocoa/Pester/Source/PSAlarmSetController.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlarmSetController.m	(revision 60)
+++ /trunk/Cocoa/Pester/Source/PSAlarmSetController.m	(revision 61)
@@ -27,4 +27,5 @@
 #import "PSMovieAlert.h"
 #import "PSSpeechAlert.h"
+#import "PSWakeAlert.h"
 
 /* Bugs to file:
@@ -124,4 +125,5 @@
     [notificationCenter addObserver: self selector: @selector(applicationWillHide:) name: NSApplicationWillHideNotification object: NSApp];
     [notificationCenter addObserver: self selector: @selector(applicationDidUnhide:) name: NSApplicationDidUnhideNotification object: NSApp];
+    [notificationCenter addObserver: self selector: @selector(applicationWillTerminate:) name: NSApplicationWillTerminateNotification object: NSApp];
     [voice setDelegate: self]; // XXX why don't we do this in IB?  It should use the accessor...
     [wakeUp setEnabled: [PSPowerManager autoWakeSupported]];
@@ -380,6 +382,8 @@
             [doSpeak setIntValue: YES];
             [voice setVoice: [(PSSpeechAlert *)alert voice]];
-        }
-    }
+        } else if ([alert isKindOfClass: [PSWakeAlert class]]) {
+            [wakeUp setIntValue: YES];
+        }
+}
 }
 
@@ -417,4 +421,7 @@
         if ([doSpeak intValue])
             [alerts addAlert: [PSSpeechAlert alertWithVoice: [voice titleOfSelectedItem]]];
+        // wake alert
+        if ([wakeUp intValue])
+            [alerts addAlert: [PSWakeAlert alert]];
         [[NSUserDefaults standardUserDefaults] setObject: [alerts propertyListRepresentation] forKey: PSAlertsSelected];
     NS_HANDLER
@@ -525,8 +532,12 @@
 @implementation PSAlarmSetController (NSApplicationNotifications)
 
+- (void)applicationWillTerminate:(NSNotification *)notification;
+{
+    [self _setAlerts];
+}
+
 - (void)applicationWillHide:(NSNotification *)notification;
 {
     if ([[self window] isVisible]) {
-        NSLog(@"hide");
         [self silence: nil];
         [self _stopUpdateTimer];
@@ -537,5 +548,4 @@
 {
     if ([[self window] isVisible]) {
-        NSLog(@"unhide");
         [self update: self];
     }
Index: /trunk/Cocoa/Pester/Source/PSAlarms.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlarms.m	(revision 60)
+++ /trunk/Cocoa/Pester/Source/PSAlarms.m	(revision 61)
@@ -9,4 +9,5 @@
 #import "PSAlarms.h"
 #import "PSAlarm.h"
+#import "PSTimer.h"
 #import "NSDictionary-NJRExtensions.h"
 
@@ -44,4 +45,5 @@
         }
         [PSAlarmsAllAlarms _updateNextAlarm]; // only generate notifications after singleton established
+        [PSTimer setUp];
     }
 }
@@ -70,7 +72,7 @@
 {
     PSAlarm *alarm = [notification object];
-    NSLog(@"timer expired: %@ retainCount %d", alarm, [alarm retainCount]);
+    // NSLog(@"timer expired: %@ retainCount %d", alarm, [alarm retainCount]);
     [expiredAlarms addObject: alarm];
-    NSLog(@"expired alarms: %@", [expiredAlarms description]);
+    // NSLog(@"expired alarms: %@", [expiredAlarms description]);
     [alarms removeObject: alarm];
     [self _changed];
@@ -80,5 +82,5 @@
 {
     PSAlarm *alarm = [notification object];
-    NSLog(@"timer set: %@ retainCount %d", alarm, [alarm retainCount]);
+    // NSLog(@"timer set: %@ retainCount %d", alarm, [alarm retainCount]);
     [alarms addObject: alarm];
     [expiredAlarms removeObject: alarm];
@@ -89,5 +91,5 @@
 {
     PSAlarm *alarm = [notification object];
-    NSLog(@"alarm died: %@ retainCount %d", alarm, [alarm retainCount]);
+    // NSLog(@"alarm died: %@ retainCount %d", alarm, [alarm retainCount]);
     [alarms removeObject: alarm];
     [expiredAlarms removeObject: alarm];
Index: /trunk/Cocoa/Pester/Source/PSAlert.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlert.h	(revision 60)
+++ /trunk/Cocoa/Pester/Source/PSAlert.h	(revision 61)
@@ -22,4 +22,5 @@
 // subclasses should implement these methods
 + (PSAlert *)alert;
+- (void)prepareForAlarm:(PSAlarm *)alarm;
 - (void)triggerForAlarm:(PSAlarm *)alarm;
 - (BOOL)requiresPesterFrontmost;
Index: /trunk/Cocoa/Pester/Source/PSAlert.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlert.m	(revision 60)
+++ /trunk/Cocoa/Pester/Source/PSAlert.m	(revision 61)
@@ -23,4 +23,9 @@
     NSAssert(NO, @"Class is abstract");
     return nil;
+}
+
+- (void)prepareForAlarm:(PSAlarm *)alarm;
+{
+    return;
 }
 
Index: /trunk/Cocoa/Pester/Source/PSAlerts.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlerts.h	(revision 60)
+++ /trunk/Cocoa/Pester/Source/PSAlerts.h	(revision 61)
@@ -28,4 +28,5 @@
 - (BOOL)requirePesterFrontmost; // do any alerts require Pester be in front?
 
+- (void)prepareForAlarm:(PSAlarm *)alarm;
 - (void)triggerForAlarm:(PSAlarm *)alarm;
 
Index: /trunk/Cocoa/Pester/Source/PSAlerts.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlerts.m	(revision 60)
+++ /trunk/Cocoa/Pester/Source/PSAlerts.m	(revision 61)
@@ -75,4 +75,9 @@
 #pragma mark actions
 
+- (void)prepareForAlarm:(PSAlarm *)alarm;
+{
+    [alerts makeObjectsPerformSelector: @selector(prepareForAlarm:) withObject: alarm];
+}
+
 - (void)triggerForAlarm:(PSAlarm *)alarm;
 {
Index: /trunk/Cocoa/Pester/Source/PSApplication.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSApplication.h	(revision 60)
+++ /trunk/Cocoa/Pester/Source/PSApplication.h	(revision 61)
@@ -11,9 +11,10 @@
 @class PSAlarmsController;
 @class PSAlarmSetController;
+@class PSTimer;
 
 @interface PSApplication : NSApplication {
     PSAlarmsController *alarmsController;
     IBOutlet PSAlarmSetController *alarmSetController;
-    NSTimer *dockUpdateTimer;
+    PSTimer *dockUpdateTimer;
     NSTimeInterval dockUpdateInterval;
     NSImage *appIconImage;
Index: /trunk/Cocoa/Pester/Source/PSApplication.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSApplication.m	(revision 60)
+++ /trunk/Cocoa/Pester/Source/PSApplication.m	(revision 61)
@@ -13,4 +13,5 @@
 #import "PSAlarm.h"
 #import "PSAlarms.h"
+#import "PSTimer.h"
 
 @implementation PSApplication
@@ -64,10 +65,10 @@
 - (void)_setUpdateTimerForInterval:(NSTimeInterval)interval alarm:(PSAlarm *)alarm repeats:(BOOL)repeats;
 {
-    dockUpdateTimer = [NSTimer scheduledTimerWithTimeInterval: interval target: self selector: @selector(_updateDockTile:) userInfo: alarm repeats: repeats];
+    dockUpdateTimer = [PSTimer scheduledTimerWithTimeInterval: interval target: self selector: @selector(_updateDockTile:) userInfo: alarm repeats: repeats];
     [dockUpdateTimer retain];
     dockUpdateInterval = interval; // because [timer timeInterval] always returns 0 once set
 }
 
-- (void)_updateDockTile:(NSTimer *)timer;
+- (void)_updateDockTile:(PSTimer *)timer;
 {
     PSAlarm *alarm = [timer userInfo];
@@ -201,9 +202,7 @@
                 NS_ENDHANDLER
             case NSAlertAlternateReturn:
-                NSLog(@"discard");
-                // [allAlarms discardVersion1Alarms];
+                [allAlarms discardVersion1Alarms];
                 break;
             case NSAlertOtherReturn:
-                NSLog(@"donÕt import");
                 break;
         }
Index: /trunk/Cocoa/Pester/Source/PSPowerManager.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSPowerManager.h	(revision 60)
+++ /trunk/Cocoa/Pester/Source/PSPowerManager.h	(revision 61)
@@ -27,6 +27,6 @@
 @interface NSObject (PSPowerManagerDelegate)
 
-- (void)powerManagerWillSleep:(PSPowerManager *)powerManager;
-- (BOOL)powerManagerShouldSleep:(PSPowerManager *)powerManager;
+- (void)powerManagerWillDemandSleep:(PSPowerManager *)powerManager;
+- (BOOL)powerManagerShouldIdleSleep:(PSPowerManager *)powerManager;
 - (void)powerManagerDidWake:(PSPowerManager *)powerManager;
 
Index: /trunk/Cocoa/Pester/Source/PSPowerManager.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSPowerManager.m	(revision 60)
+++ /trunk/Cocoa/Pester/Source/PSPowerManager.m	(revision 61)
@@ -220,11 +220,12 @@
     switch (messageType) {
         case kIOMessageSystemWillSleep:
-            if ([delegate respondsToSelector: @selector(powerManagerWillSleep:)])
-                [delegate powerManagerWillSleep: self];
-            IOAllowPowerChange(root_port, (long)messageArgument);
+            if ([delegate respondsToSelector: @selector(powerManagerWillDemandSleep:)]) {
+                [delegate powerManagerWillDemandSleep: self];
+                IOAllowPowerChange(root_port, (long)messageArgument);
+            }
             break;
         case kIOMessageCanSystemSleep:
-            if ([delegate respondsToSelector: @selector(powerManagerShouldSleep:)]) {
-                if ([delegate powerManagerShouldSleep: self]) {
+            if ([delegate respondsToSelector: @selector(powerManagerShouldIdleSleep:)]) {
+                if ([delegate powerManagerShouldIdleSleep: self]) {
                     IOAllowPowerChange(root_port, (long)messageArgument);
                 } else {
@@ -252,5 +253,4 @@
 
         delegate = [aDelegate retain];
-
         root_port = IORegisterForSystemPower(self, &notificationPort, powerCallback, &notifier);
         NSAssert(root_port != NULL, @"IORegisterForSystemPower failed");
Index: /trunk/Cocoa/Pester/Source/PSSpeechAlert.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSSpeechAlert.h	(revision 60)
+++ /trunk/Cocoa/Pester/Source/PSSpeechAlert.h	(revision 61)
@@ -4,5 +4,5 @@
 //
 //  Created by Nicholas Riley on Sat Oct 26 2002.
-//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
 //
 
Index: /trunk/Cocoa/Pester/Source/PSTimer.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSTimer.h	(revision 61)
+++ /trunk/Cocoa/Pester/Source/PSTimer.h	(revision 61)
@@ -0,0 +1,49 @@
+//
+//  PSTimer.h
+//  Pester
+//
+//  Created by Nicholas Riley on Sun Jan 05 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import <Foundation/Foundation.h>
+
+
+@interface PSTimer : NSObject {
+    BOOL isValid;
+    BOOL repeats;
+    BOOL isWakeUp;
+    NSDate *fireDate;
+    NSTimeInterval timeInterval;
+    NSInvocation *invocation;
+    id userInfo;
+}
+
++ (void)setUp;
+
+// partial emulation of Mac OS X 10.1 NSTimer interface
+// + (PSTimer *)timerWithTimeInterval:(NSTimeInterval)ti invocation:(NSInvocation *)invocation repeats:(BOOL)yesOrNo;
+// + (PSTimer *)scheduledTimerWithTimeInterval:(NSTimeInterval)ti invocation:(NSInvocation *)invocation repeats:(BOOL)yesOrNo;
+
+// + (PSTimer *)timerWithTimeInterval:(NSTimeInterval)ti target:(id)aTarget selector:(SEL)aSelector userInfo:(id)userInfo repeats:(BOOL)yesOrNo;
++ (PSTimer *)scheduledTimerWithTimeInterval:(NSTimeInterval)ti target:(id)aTarget selector:(SEL)aSelector userInfo:(id)userInfo repeats:(BOOL)yesOrNo;
+
+// - (void)fire;
+
+- (NSDate *)fireDate;
+
+// - (NSTimeInterval)timeInterval; // NSTimer’s version returns 0 once timer is scheduled
+
+- (void)invalidate;
+- (BOOL)isValid;
+
+- (id)userInfo;
+
+// other methods
+
+- (BOOL)isWakeUp;
+- (void)setWakeUp:(BOOL)doWake;
+
+- (NSComparisonResult)compare:(PSTimer *)other;
+
+@end
Index: /trunk/Cocoa/Pester/Source/PSTimer.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSTimer.m	(revision 61)
+++ /trunk/Cocoa/Pester/Source/PSTimer.m	(revision 61)
@@ -0,0 +1,246 @@
+//
+//  PSTimer.m
+//  Pester
+//
+//  Created by Nicholas Riley on Sun Jan 05 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import "PSTimer.h"
+#import "PSAlarm.h"
+#import "PSPowerManager.h"
+
+NSTimer *PSTimerCurrent = nil;
+PSTimer *PSTimerOnWake = nil;
+NSMutableArray *PSTimerAllTimers = nil;
+
+@interface PSTimer (Private)
++ (void)_schedule;
+@end
+
+@implementation PSTimer
+
++ (void)setUp;
+{
+    static PSPowerManager *powerManager;
+
+    if (powerManager == nil) {
+        powerManager = [[PSPowerManager alloc] initWithDelegate: self];
+        PSTimerAllTimers = [[NSMutableArray alloc] init];
+    }
+}
+
++ (void)_schedule;
+{
+    NSDate *aboutNow = [NSDate dateWithTimeIntervalSinceNow: 0.1];
+    [PSTimerCurrent invalidate]; [PSTimerCurrent release]; PSTimerCurrent = nil;
+    PSTimerOnWake = nil;
+    if ([PSTimerAllTimers count] > 0) {
+        PSTimer *timer = nil;
+        NSEnumerator *e;
+        [PSTimerAllTimers sortUsingSelector: @selector(compare:)];
+        // NSLog(@"_schedule: timers %@", [PSTimerAllTimers description]);
+        e = [PSTimerAllTimers objectEnumerator];
+        while ( (timer = [e nextObject]) != nil) {
+            if ([timer isWakeUp]) {
+                PSTimerOnWake = timer;
+                // NSLog(@"scheduling wake timer %@", timer);
+                break;
+            }
+        }
+        e = [PSTimerAllTimers objectEnumerator];
+        while ( (timer = [e nextObject]) != nil) {
+            if ([[timer fireDate] compare: aboutNow] != NSOrderedDescending) {
+                [timer performSelector: @selector(_timerExpired) withObject: nil afterDelay: 0];
+                return;
+            } else {
+                NSTimeInterval ti = [[timer fireDate] timeIntervalSinceNow];
+                if (ti > 0.1) {
+                    PSTimerCurrent = [[NSTimer scheduledTimerWithTimeInterval: ti target: timer selector: @selector(_timerExpired) userInfo: nil repeats: NO] retain];
+                    // NSLog(@"setting timer: %@", PSTimerCurrent);
+                } else {
+                    // NSLog(@"timer would have been too fast, setting: %@", timer);
+                    [timer performSelector: @selector(_timerExpired) withObject: nil afterDelay: 0];
+                }
+                return;
+            }
+        }
+        NSAssert(NO, @"shouldn’t get here");
+    } else {
+        // NSLog(@"_schedule: no timers");
+    }
+}
+
++ (void)_timerAdded:(PSTimer *)timer;
+{
+    NSAssert1([PSTimerAllTimers indexOfObject: timer] == NSNotFound, @"PSTimerAllTimers already contains %@", timer);
+    [PSTimerAllTimers addObject: timer];
+    [self _schedule];
+}
+
++ (void)_timerDeleted:(PSTimer *)timer;
+{
+    NSAssert1([PSTimerAllTimers indexOfObject: timer] != NSNotFound, @"PSTimerAllTimers does not contain %@", timer);
+    [PSTimerAllTimers removeObject: timer];
+    [self _schedule];
+}
+
+#pragma mark private
+
+- (void)_setFireDate:(NSDate *)date;
+{
+    if (fireDate != date) {
+        [fireDate release];
+        fireDate = [date retain];
+        if (fireDate != nil) {
+            isValid = YES;
+        }
+    }
+}
+
+- (void)_setFireDateFromInterval;
+{
+    [self _setFireDate: [NSDate dateWithTimeIntervalSinceNow: timeInterval]];
+}
+
+- (void)_invalidate;
+{
+    isValid = NO;
+    [[self class] _timerDeleted: self];
+}
+
+- (void)_timerExpired;
+{
+    if (!isValid) return; // in case the timer went off after we were invalidated
+    [self retain]; // make sure we’re still accessible during the invocation
+    // NSLog(@"timer expired: %@", self);
+    if (repeats) {
+        [invocation invoke];
+        if (isValid) {
+            [self _setFireDateFromInterval];
+            [[self class] _schedule];
+            // NSLog(@"timer repeats: %@", self);
+        }
+    } else {
+        [self _invalidate];
+        [invocation invoke];
+    }
+    [self release];
+}
+
+#pragma mark initialize-release
+
+- (id)initWithTimeInterval:(NSTimeInterval)ti target:(id)aTarget selector:(SEL)aSelector userInfo:(id)anObject repeats:(BOOL)yesOrNo;
+{
+    if ( (self = [self init]) != nil) {
+        invocation = [[NSInvocation invocationWithMethodSignature:
+            [aTarget methodSignatureForSelector: aSelector]] retain];
+        [invocation setSelector: aSelector];
+        [invocation setTarget: aTarget];
+        [invocation setArgument: &self atIndex: 2];
+        userInfo = [anObject retain];
+        repeats = yesOrNo;
+        timeInterval = ti;
+        [invocation retainArguments]; // mimics retain behavior
+        [self _setFireDateFromInterval];
+        [[self class] _timerAdded: self]; // mimics runloop retention behavior
+    }
+    return self;
+}
+
++ (PSTimer *)scheduledTimerWithTimeInterval:(NSTimeInterval)ti target:(id)aTarget selector:(SEL)aSelector userInfo:(id)anObject repeats:(BOOL)yesOrNo;
+{
+    PSTimer *timer = [[self alloc] initWithTimeInterval: ti target: aTarget selector: aSelector userInfo: anObject repeats: yesOrNo];
+    [timer release];
+    return timer;
+}
+
+- (void)dealloc;
+{
+    // NSLog(@"DEALLOC %@", self);
+    isValid = NO;
+    [fireDate release]; fireDate = nil;
+    [invocation release]; invocation = nil;
+    [userInfo release]; userInfo = nil;
+    [super dealloc];
+}
+
+#pragma mark accessing
+
+- (NSDate *)fireDate;
+{
+    return fireDate;
+}
+
+- (void)invalidate;
+{
+    repeats = NO;
+    [self _invalidate];
+}
+
+- (BOOL)isValid;
+{
+    return isValid;
+}
+
+- (id)userInfo;
+{
+    return userInfo;
+}
+
+- (BOOL)isWakeUp;
+{
+    return isWakeUp;
+}
+
+- (void)setWakeUp:(BOOL)doWake;
+{
+    isWakeUp = doWake;
+}
+
+- (NSComparisonResult)compare:(PSTimer *)other;
+{
+    return [fireDate compare: [other fireDate]];
+}
+
+- (NSString *)description;
+{
+    return [NSString stringWithFormat: @"%@: at %@ do %@ on %@", [super description], [self fireDate], NSStringFromSelector([invocation selector]), [[invocation target] class]];
+}
+
+@end
+
+@implementation PSTimer (PSPowerManagerDelegate)
+
++ (BOOL)powerManagerShouldIdleSleep:(PSPowerManager *)powerManager;
+{
+    [PSTimerCurrent invalidate];
+    if (PSTimerOnWake != nil) {
+        NSDate *date = [PSTimerOnWake fireDate];
+        NSLog(@"%lf sec remain until alarm", [date timeIntervalSinceNow]);
+        if ([date timeIntervalSinceNow] > 30) {
+            NSLog(@"going to sleep, setting timer %@", PSTimerOnWake);
+            [PSPowerManager setWakeTime: [[PSTimerOnWake fireDate] addTimeInterval: -15]];
+            return YES;
+        } else {
+            NSLog(@"not setting timer, will attempt to prevent idle sleep");
+            return NO;
+        }
+    }
+    return YES;
+}
+
++ (void)powerManagerWillDemandSleep:(PSPowerManager *)powerManager;
+{
+    [self powerManagerShouldIdleSleep: powerManager];
+    return;
+}
+
++ (void)powerManagerDidWake:(PSPowerManager *)powerManager;
+{
+    if (PSTimerCurrent != nil) {
+        [self _schedule];
+    }
+}
+
+@end
Index: /trunk/Cocoa/Pester/Source/PSWakeAlert.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSWakeAlert.h	(revision 61)
+++ /trunk/Cocoa/Pester/Source/PSWakeAlert.h	(revision 61)
@@ -0,0 +1,16 @@
+//
+//  PSWakeAlert.h
+//  Pester
+//
+//  Created by Nicholas Riley on Mon Jan 06 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import "PSAlert.h"
+
+
+@interface PSWakeAlert : PSAlert {
+
+}
+
+@end
Index: /trunk/Cocoa/Pester/Source/PSWakeAlert.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSWakeAlert.m	(revision 61)
+++ /trunk/Cocoa/Pester/Source/PSWakeAlert.m	(revision 61)
@@ -0,0 +1,45 @@
+//
+//  PSWakeAlert.m
+//  Pester
+//
+//  Created by Nicholas Riley on Mon Jan 06 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import "PSWakeAlert.h"
+
+static PSWakeAlert *PSWakeAlertShared;
+
+@implementation PSWakeAlert
+
++ (PSAlert *)alert;
+{
+    if (PSWakeAlertShared == nil)
+        PSWakeAlertShared = [[PSWakeAlert alloc] init];
+    return PSWakeAlertShared;
+}
+
+- (void)prepareForAlarm:(PSAlarm *)alarm;
+{
+    [alarm setWakeUp: YES];
+}
+
+- (void)triggerForAlarm:(PSAlarm *)alarm;
+{
+    [self completedForAlarm: alarm];
+}
+
+- (NSAttributedString *)actionDescription;
+{
+    return [@"Wake up computer if asleep" small];
+}
+
+#pragma mark property list serialization (Pester 1.1)
+
+- (id)initWithPropertyList:(NSDictionary *)dict;
+{
+    [self release];
+    return [[PSWakeAlert alert] retain];
+}
+
+@end
